#!/usr/bin/perl -w

# Reads data from a Current Cost device via serial port.

use strict;
use Device::SerialPort qw( :PARAM :STAT 0.07 );

my $PORT = "/dev/ttyUSB0";
my $meas = 0;
my $sumW = 0;
my $sumT = 0;
my $watts;
my $temp;
my $wget;


my $ob = Device::SerialPort->new($PORT)  || die "Can't open $PORT: $!\n";
$ob->baudrate(57600);
$ob->write_settings;

open(SERIAL, "+>$PORT");
while (my $line = <SERIAL>) {
    if ($line =~ m!<tmpr> *([\-\d.]+)</tmpr>.*<ch1><watts>0*(\d+)</watts></ch1>!) {
        my $watts = $2;
        my $temp = $1;
        #print "SUCCESS $meas: ... $watts, $temp\n";
        $meas++;
        $sumW += $watts;
        $sumT += $temp;
    }
    if ($meas == 10) { #time to send
    	$watts = $sumW/10;
    	$temp = $sumT/10;
        #print "AVERAGE: ... $watts, $temp\n";
        $wget = 'wget -O - \
  --header="X-ApiKey: <--- YOUR KEY HERE -->" \
  --header="X-Http-Method-Override: put" \
  --post-data "0,'.$temp."\n".'1,'.$watts.'" http://api.cosm.com/v2/feeds/<-- YOUR FEED ID -->.csv';
		#print "$wget\n";
		$response = `$wget`;
		#print $response;
      $meas = $sumW = $sumT = 0;
    }
}
